/* ARCNET trace routines
 * Copyright 1990 Russ Nelson
 */

#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "arcnet.h"
#include "trace.h"

void
#ifdef MONITOR
arc_dump(fp,bpp,check,mon)
int mon;
#else
arc_dump(fp,bpp,check)
#endif
FILE *fp;
struct mbuf **bpp;
int check;	/* Not used */
{
	struct arc ahdr;
	char s[20],d[20];

	ntoharc(&ahdr,bpp);
	parc(s,ahdr.source);
	parc(d,ahdr.dest);
#ifdef MONITOR
	if (mon)
	    fprintf(fp, "ARCNET %s->%s", s, d);
	else
#endif
	fprintf(fp,"Arcnet: len %u %s->%s",ARCLEN + len_p(*bpp),s,d);

	switch(uchar(ahdr.type)){
		case ARC_IP:
#ifdef MONITOR
	    if (mon)
		fprintf(fp, " IP ");
	    else
#endif
			fprintf(fp," type IP\n");
#ifdef MONITOR
			ip_dump(fp,bpp,1,mon);
#else
			ip_dump(fp,bpp,1);
#endif
			break;
		case ARC_ARP:
#ifdef MONITOR
	    if (mon)
		fprintf(fp, " ARP ");
	    else
#endif
			fprintf(fp," type ARP\n");
#ifdef MONITOR
			arp_dump(fp,bpp,mon);
#else
			arp_dump(fp,bpp);
#endif
			break;
		default:
			fprintf(fp," type 0x%x\n",ahdr.type);
			break;
	}
}
int
arc_forus(iface,bp)
struct iface *iface;
struct mbuf *bp;
{
	return 1;
}
