/* Ethernet header tracing routines
 * Copyright 1991 Phil Karn, KA9Q
 */
#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "enet.h"
#include "trace.h"

void
#ifdef MONITOR
#ifdef PROTOTYPES
ether_dump(FILE *fp,struct mbuf **bpp,int check,int mon)
#else
ether_dump(fp,bpp,check,mon)
int mon;
#endif
#else
#ifdef PROTOTYPES
ether_dump(FILE *fp,struct mbuf **bpp,int check)
#else
ether_dump(fp,bpp,check)
#endif
FILE *fp;
struct mbuf **bpp;
int check;	/* Not used */
#endif
{
	struct ether ehdr;
	char s[20],d[20];

	ntohether(&ehdr,bpp);
	pether(s,ehdr.source);
	pether(d,ehdr.dest);
#ifdef MONITOR
	if (mon)
	    fprintf(fp, "%s->%s", s, d);
	else
#endif
	fprintf(fp,"Ether: len %u %s->%s",ETHERLEN + len_p(*bpp),s,d);

	switch(ehdr.type){
		case IP_TYPE:
#ifdef MONITOR
	    if (mon)
		fprintf(fp, " IP ");
	    else
#endif
			fprintf(fp," type IP\n");
#ifdef MONITOR
			ip_dump(fp,bpp,1,mon);
#else
			ip_dump(fp,bpp,1);
#endif
			break;
		case REVARP_TYPE:
#ifdef MONITOR
	    if (mon)
		fprintf(fp," RARP ");
	    else
#endif
			fprintf(fp," type REVARP\n");
#ifdef MONITOR
			arp_dump(fp,bpp,mon);
#else
			arp_dump(fp,bpp);
#endif
			break;
		case ARP_TYPE:
#ifdef MONITOR
	    if (mon)
		fprintf(fp, " ARP ");
	    else
#endif
			fprintf(fp," type ARP\n");
#ifdef MONITOR
			arp_dump(fp,bpp,mon);
#else
			arp_dump(fp,bpp);
#endif
			break;
		default:
			fprintf(fp," type 0x%x\n",ehdr.type);
			break;
	}
}
int
ether_forus(iface,bp)
struct iface *iface;
struct mbuf *bp;
{
	/* Just look at the multicast bit */

	if(bp->data[0] & 1)
		return 0;
	else
		return 1;
}
